#!/bin/bash
# $Id: zen_documentar.sh,v 1.2 2007/11/30 jbelon - zenphp.es $

#/**
#  * zen_documentar - script para PHPDocumentor que permite guardar las preferencias
#  *
#  * Colocar este fichero en el directorio principal del proyecto o de aplicaciones y editar las variables
#  * para re/hacer la documentación de tu proyecto.
#  *
#  *
#  * Simplemente ejecuta phpdoc con los parámetros especificados en el fichero.
#  * NOTE: No añadir espacios después de las variables bash
#  *
#  * @copyright         zen_documentar.sh es parte del Proyecto zenphp PHPDocumentor {@link http://www.zenphp.es/} y es LGPL
#  * @author            Juan Belón <jbelon (arroba) correo (punto) ugr (punto) es>
#  * @version           1.0
#  */


##############################
# Para editar:
##############################

#/**
#  * Título de la documentación generada, por defecto es 'Generated Documentation'
#  *
#  * @var               string ZF_TITULO
#  */
ZF_TITULO="Documentación del sistema zenphp"

#/**
#  * Nombre que se quiere usar para el paquete por defecto. Si no se especifica se usa 'default'
#  * y es del tipo clase.Fichero.php
#  * @var               string ZF_PAQUETES
#  */
ZF_PAQUETES="zenphp"

#/**
#  * Nombre del directorio/s a documentar directorio1,directorio2,etc.
#  * $PWD es el directorio donde se encuentra zen_documentar.sh
#  *
#  * @var               string ZF_RUTA_PROYECTO
#  */
#ZF_RUTA_PROYECTO=$PWD
ZF_RUTA_PROYECTO=$PWD"/.."
#/**
#  * Ruta del ejecutable de PHPDoc
#  *
#  * @var               string ZF_RUTA_PHPDOC
#  */
ZF_RUTA_PHPDOC=/home/juax/PhpDocumentor-1.4.1/phpdoc

#/**
#  * Ruta donde se escribirá la documentación
#  *
#  * @var               string ZF_RUTA_DOCS
#  */
ZF_RUTA_DOCS=$PWD/docs

#/**
#  * Formato a usar para la salida:(html/pdf)
#  *
#  * @var               string ZF_FORMATO_SALIDA
#  */
ZF_FORMATO_SALIDA=HTML

#/**
#  * Convertidor a usar (Smarty)
#  *
#  * @var               string ZF_CONVERTIDOR
#  */
ZF_CONVERTIDOR=Smarty

#/**
#  * Plantilla a usar
#  *
#  * @var               string ZF_PLANTILLA
#  */
ZF_PLANTILLA=default

#/**
#  * Procesar elementos privados
#  *
#  * @var               bool (on/off)           ZF_PRIVADOS
#  */
ZF_PRIVADOS=on

# make documentation
php $ZF_RUTA_PHPDOC -d $ZF_RUTA_PROYECTO -t $ZF_RUTA_DOCS -ti "$ZF_TITULO" -dn $ZF_PAQUETES \
-o $ZF_FORMATO_SALIDA:$ZF_CONVERTIDOR:$ZF_PLANTILLA -pp $ZF_PRIVADOS


# vim: set expandtab
